package cn.fw.dalaran.domain.enums;

import com.baomidou.mybatisplus.core.enums.IEnum;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import lombok.Getter;

/**
 * @author kurisu
 * @date 2020-08-11 17:37
 * @description 平台   1：快手 2：抖音
 */
public enum PlatformEnum implements IEnum<Integer> {

    KS(1, "快手"),// 快手
    DY(2, "抖音"),// 抖音
    DCD(3, "懂车帝"),// 懂车帝
    BILIBILI(4, "哔哩哔哩"),// 哔哩哔哩
    WX(5, "微信视频号"),// 微信视频号
    ;

    /**
     * 值
     */
    private final Integer value;
    /**
     * 名称
     */
    @Getter
    private final String name;

    PlatformEnum(final Integer value, final String name) {
        this.value = value;
        this.name = name;
    }

    /**
     * 根据枚举值获取枚举对象
     */
    @JsonCreator
    public static PlatformEnum ofValue(final Integer value) {
        for (final PlatformEnum typeEnum : PlatformEnum.values()) {
            if (typeEnum.value.equals(value)) {
                return typeEnum;
            }
        }
        return null;
    }

    /**
     * 获取值
     *
     * @return 值
     */
    @JsonValue
    @Override
    public Integer getValue() {
        return value;
    }

    /**
     * 获取描述
     *
     * @return 值
     */
    @JsonCreator
    public static String getNameByVale(final Integer value) {
        for (final PlatformEnum typeEnum : PlatformEnum.values()) {
            if (typeEnum.value.equals(value)) {
                return typeEnum.getName();
            }
        }
        return "";
    }
}
