package cn.fw.dalaran.domain.param;

import cn.fw.dalaran.domain.db.ActivityTheme;
import com.alibaba.fastjson.JSON;
import lombok.Data;

import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.NotNull;
import java.util.List;
import java.util.stream.Collectors;

/**
 * @author wmy3969
 * @version 1.0
 * @date 2022/5/31 19:53
 * @Description 增加话题带参
 */
@Data
public class AddThemeTopicParams {
    /**
     * 活动主题id
     */
    @NotNull(message = "活动主题id不能为空")
    private Long themeId;
    /**
     * 活动话题
     */
    @NotEmpty(message = "话题不能为空")
    private List<String> topic;

    /**
     * vo->db
     *
     * @return 将视图传参转换成DB
     */
    public static ActivityTheme toDB(AddThemeTopicParams vo) {
        final ActivityTheme db = new ActivityTheme();
        db.setId(vo.getThemeId());
        db.setTopic(JSON.toJSONString(vo.getTopic().stream()
                .map(item -> {
                    String replace = item.replace("#", "");
                    return "#" + replace;
                })
                .collect(Collectors.toList()))
                .replace("[", "")
                .replace("]", "")
                .replace("\"", ""));
        return db;
    }
}
