package cn.fw.dalaran.domain.vo;

import cn.fw.dalaran.domain.enums.BizTypeEnum;
import cn.fw.dalaran.domain.param.EvlParams;
import lombok.Data;
import lombok.ToString;
import org.springframework.beans.BeanUtils;

import java.math.BigDecimal;

/**
 * @author kurisu
 * @date 2021-11-18 11:07
 * @description 评价指标
 */
@Data
@ToString
public class EvlIndexVO {
    private Long id;
    /**
     * 类型
     */
    private BizTypeEnum type;
    /**
     * 占比 （%）
     */
    private BigDecimal rate;
    /**
     * 所属配置组id
     */
    private Long configGroupId;

    public String getTypeDesc() {
        return type.getName();
    }

    public static EvlParams.EvlIndex toIndex(EvlIndexVO vo) {
        final EvlParams.EvlIndex db = new EvlParams.EvlIndex();
        BeanUtils.copyProperties(vo, db);
        return db;
    }
}
