package codeGenerator;

import com.baomidou.mybatisplus.annotation.DbType;
import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.generator.AutoGenerator;
import com.baomidou.mybatisplus.generator.config.DataSourceConfig;
import com.baomidou.mybatisplus.generator.config.GlobalConfig;
import com.baomidou.mybatisplus.generator.config.PackageConfig;
import com.baomidou.mybatisplus.generator.config.StrategyConfig;
import com.baomidou.mybatisplus.generator.config.po.TableFill;
import com.baomidou.mybatisplus.generator.config.rules.DateType;
import com.baomidou.mybatisplus.generator.config.rules.NamingStrategy;
import org.junit.Test;

import java.util.ArrayList;

public class CodeGenerator {

    @Test
    public void getCode() {
        // 1、全局配置
        GlobalConfig globalConfig = new GlobalConfig();
        globalConfig
                .setOutputDir("D:\\Users\\wmy\\feiweiProjects\\fw-dalaran\\fw-dalaran-domain\\src\\main\\java\\codeGenerate" + "/src/main/java")//1.修改为你项目的目录
                .setActiveRecord(true) //是否支持AR模式
                .setOpen(false)//生成后是否打开资源管理器
                .setAuthor("wmy3969") //作者
                .setFileOverride(true) //文件覆盖
                .setIdType(IdType.AUTO) //主键策略
                .setDateType(DateType.ONLY_DATE)//定义生成的实体类中日期类型
                .setServiceName("%sService")//去掉Service接口的首字母I
                .setBaseResultMap(true) //外部命名引用
                .setBaseColumnList(true) //生成SQL 片段
                .setSwagger2(false);//开启Swagger2模式
        // 2、数据源配置
        DataSourceConfig dataSourceConfig = new DataSourceConfig();
        dataSourceConfig
                .setDbType(DbType.MYSQL)
                .setUrl("jdbc:mysql://192.168.0.9:3306/fw_dalaran?characterEncoding=UTF-8&useSSL=false")//2.修改为你数据库的名字，用户名，密码
                .setDriverName("com.mysql.jdbc.Driver")
                .setUsername("test")
                .setPassword("mysql@pwd123");
        // 3、包配置
        PackageConfig packageConfig = new PackageConfig();
        packageConfig
                .setModuleName("edu") //模块名
                .setParent("cn.zf.service")
                .setController("controller")
                .setEntity("entity")
                .setService("service")
                .setMapper("mapper")
                .setXml("mapper.xml");
        // 4.修改自动填充字段名
        ArrayList<TableFill> tableFills = new ArrayList<>();
        TableFill create = new TableFill("create_time", FieldFill.INSERT);
        TableFill update = new TableFill("update_time", FieldFill.INSERT_UPDATE);
        tableFills.add(create);
        tableFills.add(update);
        // 5、策略配置
        StrategyConfig strategyConfig = new StrategyConfig();
        strategyConfig
                .setCapitalMode(true) //全局大写命名
                .setNaming(NamingStrategy.underline_to_camel)//数据库表映射到实体的命名策略
                //.setInclude("edu_teacher")
                .setTablePrefix(packageConfig.getModuleName() + "_") //生成实体时去掉表前缀
                .setColumnNaming(NamingStrategy.underline_to_camel)// 数据库表字段映射到实体的命名策略
                .setEntityLombokModel(true)// lombok 模型 @Accessors(chain = true) setter链式操作
                .setLogicDeleteFieldName("logic_del") // 3.修改逻辑删除字段名
                .setEntityBooleanColumnRemoveIsPrefix(true) // 去掉布尔值is_前缀
                .setRestControllerStyle(false) // restful api风格控制器
                .setControllerMappingHyphenStyle(true) // url中驼峰转连字符
                .setInclude("global_config") //生成的表
                .setTableFillList(tableFills);
        // 6、创建代码生成器
        AutoGenerator autoGenerator = new AutoGenerator();
        autoGenerator
                .setGlobalConfig(globalConfig)
                .setDataSource(dataSourceConfig)
                .setPackageInfo(packageConfig)
                .setStrategy(strategyConfig);
        // 7、执行
        autoGenerator.execute();
    }

}
